/* colorprint.c
 * functions for pretty formatting
 */

#define _FOO_H_
#include "colorprint.h"
#include <ctype.h>
#include <stdio.h>

#define CPL 16	/* TODO: should find tty width from termcap (?) */

void hexlprint(unsigned char *data, int datalen);

void hexlprint(unsigned char *data, int datalen) {
	int i, j, linestart=0;

	for(i=0;i<datalen;i++) {
		if(!(i % CPL)) {   /* End of line - dump text */
			printf(" ");
			for(j = linestart; j<i; j++) {
				if(isprint(*(data+j))) {
					GREEN printf("%c",*(data+j));
				} else {
					GRAY printf(".");  /* not printable */
				}
			}
			NORMAL;
			TEXT BLUE printf("%08X: ",i); /* offset */
			CYAN;
			linestart=i;  /* save start pos for next time round */
		}
		printf("%02X",*(data+i));
		if(i&1) printf(" ");
	}

	/* Do the last bit */
	for(i=0;i<CPL-(datalen%CPL);i++) {
		printf("  ");
		if(i&1) printf(" ");
	}
	printf(" ");
	for(j = linestart; j<datalen; j++) {
		if(isprint(*(data+j))) {
			GREEN printf("%c",*(data+j));
		} else {
			GRAY printf(".");
		}
	}
	NORMAL;
}
