/* udp.c
 * prints out the contents of a UDP packet header
 */

#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "colorprint.h"
#include "csum.h"

void printUDPpacket (unsigned char *packet, int packlen, unsigned char *iphdr);

void printUDPpacket (unsigned char *packet, int packlen, unsigned char *iphdr){
	unsigned short *nextword = (unsigned short *)packet;
	unsigned short check, check2;
	int len;

	struct servent *port;

	HEAD printf("UDP HEADER:") NORMAL;

	if(packlen < 4) {
		WARN printf("Packet contains nothing helpful.  Bailing out") NORMAL;
		return;
	}	

	port = getservbyport(*nextword,"udp");
	TEXT printf("Source port: %u",ntohs(*nextword));
	if(port) {
		OK printf("(%s)",port->s_name) NORMAL;
	} else {
		WARN printf("(unknown)") NORMAL;
	}
	nextword++;

	port = getservbyport(*nextword,"udp");
	TEXT printf("Destination port: %u",ntohs(*nextword));
	if(port) {
		OK printf("(%s)",port->s_name) NORMAL;
	} else {
		WARN printf("(unknown)") NORMAL;
	}
	nextword++;
	endservent();

	if(packlen < 6) {
		WARN printf("Reached end of packet") NORMAL;
		return;
	}
	TEXT printf("Length:");
	len = ntohs(*nextword);
	TESTPRINTu(len > 7,len,"should be at least 8") NORMAL;
	nextword++;

	check = *nextword;
	*nextword=0;  /* zero checksum to compute what it should be */
	check2 = udpcsum(iphdr,(unsigned short *)packet,packlen);
	*nextword = check;  /* and restore it afterwards, just in case */

	TEXT printf("UDP Checksum:");
	if(check == 0) {
		WARN printf("0000 (no checksum)") NORMAL;
	} else if(len > packlen) {
		WARN printf("%04X (can't check - incomplete packet)",check) NORMAL;
	} else {
		if(check == 0xFFFF) check = 0;
		PRINTCSUM(check,check2) NORMAL;
	}
	
	return;
}
